;+=----------------------------------------------------------------------------
; Name  : mrlib_init
; RCS   : $Id: mrlib_init.pro,v 2.4 2004/11/10 10:53:34 olivert Exp olivert $
; Syntax: mrlib_init
; Desc  : Compiles all functions, procedures and classes of the library
;         and assures all dependencies are resolved.
; Author: (c) Oliver Thilmann, oliver.thilmann@web.de
; Licns : This program is published under the GPL. See gpl.txt for details
;=-----------------------------------------------------------------------------
pro mrlib_init

	common mrlib_init, compiled

	if( n_elements(compiled) ne 0 ) then return
	compiled = 1

	device, decomposed=0

	funcs = [ $
		'mrlib_version'             ,$
		'color_getidx'				,$ ; helper functions
		'color_getrgb'				,$
		'intersect'					,$
		'CreateTrueColorImg'		,$
		'mrwidget_numfield'         ,$
		'mrwidget_fileselect'       ,$
		'mrdialog_select'			,$
		'dirname'					,$
		'mrGetImageSet'				]

	pros = [ $
		'color_init'				,$
		'mri18n__define'            ,$ ; translations for the classes
		'hcolorbar__define'			,$ ; graphic 'primitives'
		'vcolorbar__define'			,$
		'mrerror__define'			,$ ; error handling
		'mrprogressbar__define'		,$ ; the progress bar
		'mrnotify__define'          ,$ ; notification
		'mrcontainer__define'       ,$ ; container with callback
		'mrdisplay__define'			,$ ; the display objects and plugins
		'mrmultidisplay__define'	,$
		'mrzoom__define'			,$
		'mrpan__define'				,$
		'mrcontrast__define'		,$
		'mrcursorinfo__define'      ,$
		'mrdataflash__define'		,$
		'mrdicom__define'			,$ ; dicom input and output
		'mrimageset__define'        ,$
		'mrimagesetdicom__define'   ,$
		'mrparameter__define'		,$ ; the data structures
		'mrparameterset__define'	,$
		'mrhash__define'			,$
		'mrroi__define'			    ,$ ; all roi stuff
		'mrroidot__define'			,$
		'mrroirect__define'			,$
		'mrroicirc__define'			,$
		'mrroipoly__define'			,$
		'mrroigroup__define'		,$
		'mrroiui__define'			]

	for i = 0, n_elements(funcs)-1 do begin
		resolve_routine, funcs[i], /compile_full_file, /is_function
	end
	for i = 0, n_elements(funcs)-1 do begin
		resolve_routine, funcs[i], /compile_full_file, /is_function
	end
	for i = 0, n_elements(pros)-1 do begin
		resolve_routine, pros[i], /compile_full_file
	end
	for i = 0, n_elements(pros)-1 do begin
		resolve_routine, pros[i], /compile_full_file
	end

end
