;+=----------------------------------------------------------------------------
; Name  : findDicomParent
; Syntax: parent = findDicomParent( imgSet )
; Desc  : Tries to find an image set of class mrImageSetDicom in the ancestry
;         of imgSet and returns it, if found, or obj_new() if none exists.
;=-----------------------------------------------------------------------------
function findDicomParent, imgset
	set = imgset
	while( not obj_isa( set, 'mrImageSetDicom' )) do begin
		if( not obj_valid( set->parent() ) )then return, obj_new()
		set = set->parent()
	end
	return, set
end