;+=----------------------------------------------------------------------------
; Name    : init_i18n
; RCS     : $Id: init_i18n.pro,v 1.0 2004/09/08 09:33:28 olivert Exp olivert $
; Desc    :
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------
function init_i18n, g

		; Create a hash-table that will hold all entries

	(*g).i18n = obj_new('mrhash', 'string', blocksize=200 )
	if( (*g).i18n eq obj_new() ) then return, 0

		; The language to use has been loaded with the preferences

	lang = (*(*g).preferences).lang->get()
	file = 'i18n/' + lang + '.i18n'

		; Initialize the localization for the library

	case lang of
	'Deutsch':  (mrI18n())->setLocale, 'de-de'
	'Svenska':  (mrI18n())->setLocale, 'sv-se'
	'Francais': (mrI18n())->setLocale, 'fr-fr'
	else:       (mrI18n())->setLocale, 'en-us'
	end

		; Load the language file and return the result

	res = (*g).i18n->load( file, count=count )
	return, res
end