;+=----------------------------------------------------------------------------
; Name    : lupe
; RCS     : $Id: lupe.pro,v 1.3 2004/11/25 09:51:00 olivert Exp olivert $
; Calls   : lunlib_init
;           init_globals
;           init_modules
;           mod_prefs::load
;           init_i18n
;           init_gui
;           lupe_reset
;           mod_logo::map
; Desc    : The lund perfusion program
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------
pro lupe

;	catch, error_status
;	if( error_status ne 0 ) then begin
;		catch, /cancel
;		help, /last_message, output=messages
;		help, calls=stacktrace
;		print, stacktrace
;		if( ptr_valid( gp ) ) then begin
;			for i = 0, n_elements(messages)-1 do (*gp).e->error, messages[i]
;		end else begin
;			for i = 0, n_elements(messages)-1 do print, messages[i]
;		end
;		return
;	end


		;
		; Compile the library - just to be on the safe side
		;

	mrlib_init

		;
		; Create and initialize the global structure
		;

	g                 = init_globals()
	(*g).version      = '1.2'
	(*g).version_date = '25.11.2004'

		;
		; Instanciate all module objects
		;

	res = init_modules( g )
	if( res eq 0 ) then begin
		x = dialog_message(['Fatal error during module initialization.','Please contact the author.'], /error)
		return
	end

		;
		; Load preferences
		;

	prefs = (*g).modules->get('mod_prefs')
	res = prefs->load()
	if( res eq 0 ) then begin
		x = dialog_message(['Error loading preferences.', 'Create default preference file?'], /question )
		if( strlowcase(x) eq 'yes' ) then begin
			prefs->setDefaults
			res = prefs->save()
			if( res eq 0 ) then begin
				x = dialog_message(['Error creating default file', 'Now you are doomed'], /error )
				return
			end else begin
				x = dialog_message(['Created default preferences file'], /info )
			end
		end else begin
			return
		end
	end
	if( (*(*g).preferences).workingdir ne '' ) then (*g).workingdir = (*(*g).preferences).workingdir

		;
		; Initialize mrDicom
		;

	mrdicom_setUIDs, 'mrimg', (*(*g).preferences).implementationClassUID

		;
		; Instanciate and load i18n
		;

	res = init_i18n( g )
	if( res eq 0 ) then begin
		x = dialog_message(['I18N initialization failed.', 'Exiting.'], /error)
		return
	end

		;
		; At this point we might either start an interactive version or
		; allow for batch processing.
		; For now it's interactive only
		;

		;
		; Initialize the UI
		; Create pointer to globals in top widget's uvalue
		;

    topid   = init_gui( g )
    if( topid eq 0L ) then begin
		x = dialog_message(['GUI initialization failed.','This is fatal :-('], /error)
		return
	end
    (*g).topid = topid

		;
		; reset the whole thing (needed? Right now, it does nothing)
		;

	lupe_reset, g

		;
    	; map mod_logo
    	;

	mod_logo = (*g).modules->get( 'mod_logo' )
	mod_logo->map
	(*g).emb_module = mod_logo

		;
		; and startup
		;

    widget_control, (*g).topid, /realize
    widget_control, (*g).topid, set_uvalue=g
    xmanager, 'Lupe',  (*g).topid, event_handler='lupe_evthandler', /no_block

end
