;+=----------------------------------------------------------------------------
; Name    : mod_about
; RCS     : $Id: mod_about__define.pro,v 1.1 2004/11/11 11:20:48 olivert Exp olivert $
; Desc    : Who did it? That's what it's about.
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------

;+=----------------------------------------------------------------------------
; Name  : mod_about::init
; Desc  :
;=-----------------------------------------------------------------------------
function mod_about::init, g
    res = self->lupemod::init( 'mod_about', 'top', 0, g )
    if( res eq 0 ) then return, 0
	return, 1
end

function mod_about::revision
	rev = '$Revision: 1.1 $'
	return, rev
end

;+=----------------------------------------------------------------------------
; Name  : mod_about::readyToExecute
; Desc  : Can always be executed
;=-----------------------------------------------------------------------------
function mod_about::readyToExecute, label
	return, 1
end


;+=----------------------------------------------------------------------------
; Name  : mod_about::map
; Desc  :
;=-----------------------------------------------------------------------------
pro mod_about::map, option

		; create the base widget

	res = self->createBaseWidget( /column, /base_align_center, title=(*self.g).i18n->get('about_title') )
	if( res eq 0 ) then return

		; let's have that a bit nicer. later.

	x = widget_label( self.baseid, value='', scr_ysize=10 )
	b = widget_base ( self.baseid, /column, /frame, xsize=250, /align_center )
	x = widget_label( b, value='Lupe Version ' + (*self.g).version )
	x = widget_label( b, value=(*self.g).version_date )
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='(c) 2004 Oliver Thilmann' )
	x = widget_label( b, value='Dept. of Medical Radiation Physics')
	x = widget_label( b, value='Lund University Hospital' )
	x = widget_label( b, value='221 85 Lund, Sweden' )
	x = widget_label( b, value='E-Mail: oliver.thilmann@radfys.lu.se' )
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='Please check for newer versions on:' )
	x = widget_label( b, value='http://www.jubileum.lu.se/mrphysics/software.htm' )
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='The author wishes to thank the' )
	x = widget_label( b, value='Akademie der Naturforscher Leopoldina' )
	x = widget_label( b, value='Halle, Germany, for their support.' )


	x = widget_label( self.baseid, value=' ' )
	b = widget_base( self.baseid, /row )
	;x = widget_button( b, value='Contribute', xsize=70, uvalue={o:self, m:'morebutton'} )
	x = widget_button( b, value='License', xsize=70, uvalue={o:self, m:'licensebutton'} )
	x = widget_button( b, value='OK', xsize=70, uvalue={o:self, m:'okbutton'} )

	self->placeAndRegister

end

;+=----------------------------------------------------------------------------
; Name  : mod_about__define
; Desc  : Private Procedure (constructor)
;=-----------------------------------------------------------------------------
pro mod_about__define
	obj = { MOD_ABOUT		   		,$
			inherits LUPEMOD   		 $
		  }
end


;==============================================================================
;
;                                  EVENT HANDLING
;
;==============================================================================

;+=----------------------------------------------------------------------------
; Name  : mod_about::okbutton
; Desc  : Unmapping
;=-----------------------------------------------------------------------------
pro mod_about::okbutton, evt
	self->unmap
end


;+=----------------------------------------------------------------------------
; Name  : mod_about::licensebutton
; Desc  : The GPL license reference
;=-----------------------------------------------------------------------------
pro mod_about::licenseButton, evt
	self->unmap

	res = self->createBaseWidget( /column, /base_align_center, title=(*self.g).i18n->get('about_title') )
	if( res eq 0 ) then return

	x = widget_label( self.baseid, value='', scr_ysize=10 )
	b = widget_base ( self.baseid, /column, /frame, xsize=350, /align_center )
	x = widget_label( b, value='Lupe Version ' + (*self.g).version )
	x = widget_label( b, value=(*self.g).version_date )
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='This program is free software; you can redistribute it and/or modify')
    x = widget_label( b, value='it under the terms of the GNU General Public License as published by')
    x = widget_label( b, value='the Free Software Foundation; either version 2 of the License, or')
    x = widget_label( b, value='(at your option) any later version.')
    x = widget_label( b, value=' ' )
	x = widget_label( b, value='This program is distributed in the hope that it will be useful,')
    x = widget_label( b, value='but WITHOUT ANY WARRANTY; without even the implied warranty of')
    x = widget_label( b, value='merchantability or fitness for a particular purpose.')
    x = widget_label( b, value='(That includes the calculation of perfusion images.)')
    x = widget_label( b, value='See the GNU General Public License for more details.')
    x = widget_label( b, value=' ' )
	x = widget_label( b, value='You should have received a copy of the GNU General Public License')
    x = widget_label( b, value='along with this program; if not, write to the Free Software')
    x = widget_label( b, value='Foundation, Inc., 59 Temple Place, Suite 330')
    x = widget_label( b, value='Boston, MA  02111-1307  USA' )
	x = widget_label( self.baseid, value=' ' )
	b = widget_base( self.baseid, /row )
	;x = widget_button( b, value='More', xsize=70, uvalue={o:self, m:'morebutton'} )
	x = widget_button( b, value='Lupe', xsize=70, uvalue={o:self, m:'lupebutton'} )
	x = widget_button( b, value='OK', xsize=70, uvalue={o:self, m:'okbutton'} )

	self->placeAndRegister

end

;+=----------------------------------------------------------------------------
; Name  : mod_about::contributeButton
; Desc  : Since you're already here reading the source code...
;=-----------------------------------------------------------------------------
pro mod_about::contributeButton, evt
	self->unmap

	res = self->createBaseWidget( /column, /base_align_center, title=(*self.g).i18n->get('about_title') )
	if( res eq 0 ) then return

	x = widget_label( self.baseid, value='', scr_ysize=10 )
	b = widget_base ( self.baseid, /column, /frame, xsize=350, /align_center )
	x = widget_label( b, value='Lupe')
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='The program is published in the hope that people' )
	x = widget_label( b, value='will find it useful and maybe even contribute' )
	x = widget_label( b, value='additional modules or calculation techniques.' )
	x = widget_label( b, value=' ' )
	x = widget_label( b, value='If you should not be familiar with IDL or do not' )
	x = widget_label( b, value="want to dig into the program framework, I'll be" )
	x = widget_label( b, value='happy to convert your (well documented) code and send' )
	x = widget_label( b, value='a version for verification before publication.' )
	x = widget_label( b, value=' ' )
	x = widget_label( self.baseid, value=' ' )
	b = widget_base( self.baseid, /row )
	x = widget_button( b, value='Contribute', xsize=70, uvalue={o:self, m:'contributeButton'} )
	x = widget_button( b, value='Lupe', xsize=70, uvalue={o:self, m:'lupeButton'} )
	x = widget_button( b, value='OK', xsize=70, uvalue={o:self, m:'okButton'} )

	self->placeAndRegister

end

;+=----------------------------------------------------------------------------
; Name  : mod_about::lupeButton
; Desc  : The main 'about'
;=-----------------------------------------------------------------------------
pro mod_about::lupeButton, evt
	self->unmap
	self->map
end