;+=----------------------------------------------------------------------------
; Name    : mod_logo
; RCS     : $Id: mod_logo__define.pro,v 1.1 2004/11/11 11:34:03 olivert Exp olivert $
; Desc    : Maps the logo on screen, if nobody else needs it
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------
function mod_logo::revision
	rev = '$Revision: 1.1 $'
	return, rev
end

;+=----------------------------------------------------------------------------
; Name  : mod_logo::init
; Syntax: obj = obj_new('lupemod', type, exclusive )
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
function mod_logo::init, g

		; catch errors from image loading

	error_status = 0
	catch, error_status
	if( error_status ne 0 ) then begin
		catch, /cancel
		print, !ERROR_STATE.MSG
		self.img = ptr_new()
		self.colortable = ptr_new()
		return, 1
	end

		; initialize

	res = self->lupemod::init( 'mod_logo', 'embedded', 0, g )
	if( res eq 0 ) then return, 0

	filename = (*g).homedir + '/Logos/lupe_logo.jpg'
	read_jpeg, filename, img, colortable, colors=256
	self.img = ptr_new( img, /no_copy )
	self.colortable = ptr_new( colortable, /no_copy )

	return, 1
end

;+=----------------------------------------------------------------------------
; Name  : mod_logo::readyToExecute
; Syntax:
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
function mod_logo::readyToExecute, option
	return, 1
end


;+=----------------------------------------------------------------------------
; Name  : mod_logo::map
; Syntax:
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
pro mod_logo::map, option
	i18n = (*self.g).i18n
	res = self->createBaseWidget( /column )
	x = widget_draw( self.baseid, xsize=1007, ysize=689 )
	self->placeAndRegister
	widget_control, x, get_value=win
	wset, win
	tvlct, r, g, b, /get
	if( self.img ne ptr_new() ) then begin
		tvlct, *self.colortable
		tv, *self.img, 103, 45
	end else begin
		tvlct, 0, 0, 255, 0 ; blue
		xyouts, 400, 360, i18n->get('logo_errLoadingLogo'), color=0, charsize=3, /device, font=2
	end
	tvlct, r, g, b
end

;+=----------------------------------------------------------------------------
; Name  : mod_logo::unmap
; Syntax:
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
pro mod_logo::unmap, killed=killed, nologo=nologo
	self->lupemod::unmap, /nologo
end

;+=----------------------------------------------------------------------------
; Name  : mod_logo__define
; Desc  : Private Procedure (constructor)
;=-----------------------------------------------------------------------------
pro mod_logo__define
	obj = { mod_logo		   		,$
			inherits LUPEMOD   		,$
			img:		ptr_new()	,$ ; the image data
			colortable:	ptr_new()	 $ ; and the corresponding color table
		  }
end