;+=----------------------------------------------------------------------------
; Name    : mod_modinfo
; RCS     : $Id: mod_modinfo__define.pro,v 1.1 2004/11/11 11:34:25 olivert Exp olivert $
; Desc    : Print module version information.
;           This module creates a small top-level window containing the
;           version information and just one button for closing the window.
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------

;+=----------------------------------------------------------------------------
; Name  : mod_modinfo::init
; Desc  :
;=-----------------------------------------------------------------------------
function mod_modinfo::init, g
    res = self->lupemod::init( 'mod_modinfo', 'top', 0, g )
    if( res eq 0 ) then return, 0
	return, 1
end

function mod_modinfo::revision
	rev = '$Revision: 1.1 $'
	return, rev
end

;+=----------------------------------------------------------------------------
; Name  : mod_modinfo::readyToExecute
; Desc  : Can always be executed
;=-----------------------------------------------------------------------------
function mod_modinfo::readyToExecute, option
	return, 1
end


;+=----------------------------------------------------------------------------
; Name  : mod_modinfo::map
; Desc  :
;=-----------------------------------------------------------------------------
pro mod_modinfo::map, option

		; create the base widget

	res = self->createBaseWidget( /column )
	if( res eq 0 ) then return

		; this shall be nicer later with logo and all
		; for now it's just revision info

	x = widget_label( self.baseid, value=' ' )
	x = widget_label( self.baseid, value='Lupe Version: ' + (*self.g).version )
	x = widget_label( self.baseid, value='MR Library Version: ' + mrlib_version() )
	x = widget_label( self.baseid, value=' ' )
	x = widget_base( self.baseid, column=2 )
	l = widget_base( x, /column )
	r = widget_base( x, /column )
	all = (*self.g).modules->keys( count=nmods )
	for i = 0, nmods-1 do begin
		module = (*self.g).modules->get(all[i])
		x = widget_label( l, value=all[i] + ' : ', /align_left )
		x = widget_label( r, value=module->revision(), /align_left )
	end

	x = widget_label( self.baseid, value=' ' )
	x = widget_button( self.baseid, value='OK', scr_xsize=20, xsize=20, uvalue={o:self, m:'okbutton'}, tooltip='nuff said' )

	self->placeAndRegister

end

;+=----------------------------------------------------------------------------
; Name  : mod_modinfo__define
; Desc  : Private Procedure (constructor)
;=-----------------------------------------------------------------------------
pro mod_modinfo__define
	obj = { MOD_MODINFO		   		,$
			inherits LUPEMOD   		 $
		  }
end


;==============================================================================
;
;                                  EVENT HANDLING
;
;==============================================================================

;+=----------------------------------------------------------------------------
; Name  : mod_modinfo::okbutton
; Desc  : Just unmap
;=-----------------------------------------------------------------------------
pro mod_modinfo::okbutton, evt
	self->unmap
end

