;+=----------------------------------------------------------------------------
; Name    : mod_MODNAME
; RCS     : $Id: mod_template.pro,v 1.1 2004/11/11 11:37:39 olivert Exp olivert $
; Desc    :
;
;    This is the template - replace MODNAME case sensitive with the module name
;
; When you're done, add the necessary lines to init_modules
;
; If this module is accessible via a menu entry, add the line(s) to menu.xml
; and translations to all i18n files (at least placeholders for unfamiliar languages)
;
; Author  : (c) 2004 Oliver Thilmann
;=------------------------------------------------------------------------------
function mod_MODNAME::revision
	rev = '$Revision: 1.1 $'
	return, rev
end

;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::init
; Syntax: obj = obj_new('lupemod', type, exclusive )
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
function mod_MODNAME::init, g

		; define module structure here, if one is neede

	XXX = {	lupe_MODNAME					 ,$
   				X:				  obj_new()   $ ; a mrparameter object to hold the languages
	}

    res = self->lupemod::init( 'mod_MODNAME', 'XXX', 1, g )
    if( res eq 0 ) then return, 0

	return, 1
end


;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::readyToExecute
; Syntax:
; Args  :
; Desc  :
;=-----------------------------------------------------------------------------
function mod_MODNAME::readyToExecute, option
	return, 0
end


;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::map
; Desc  : Use for 'top' and 'embedded' modules
;=-----------------------------------------------------------------------------
pro mod_MODNAME::map, option

		; create the base widget - don't provide screen-size and title for an embedded widget!

	res = self->createBaseWidget( /column, scr_xsize=xxx, scr_ysize=xxx, title='MODNAME' )
	if( res eq 0 ) then return

		; user code starts here


		; and ends here

		; realize the widget and register with the xmanager

	self->placeAndRegister
end

;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::unmap
; Syntax:
; Args  : <b>killed</b>
;         If the user killed the window via Ctrl-F4 or the close handle (the
;         cross at the upper right), killed is set to '1'. In this case it
;         might be (I have not tested this) that the system's window manager
;         has already removed the window from screen.
; Desc  :
;=-----------------------------------------------------------------------------
pro mod_MODNAME::unmap, _ref_extra=ex

	if( self.baseid eq 0L ) then return  ; uups - we don't exist :( Shouldn't happen

		; place module cleanup code here

		; destruction of the window and some book-keeping is done by the superclass
		; Pass on the extra keywords!

	self->lupemod::unmap, _strict_extra=ex
end

;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::execute
; Desc  : Use for 'noui' modules - 'top' and 'embedded' modules use map and unmap
;=-----------------------------------------------------------------------------
pro mod_MODNAME::execute, option
end


;==============================================================================
;
;                           E V E N T   H A N D L I N G
;
;==============================================================================

;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME::Evt
; Desc  : one of many event handlers
;=-----------------------------------------------------------------------------
pro mod_MODNAME::Evt, evt
end


;==============================================================================
;
;                                 I N T E R N A L
;
;==============================================================================


;+=----------------------------------------------------------------------------
; Name  : mod_MODNAME__define
; Desc  : Private Procedure (constructor)
;=-----------------------------------------------------------------------------
pro mod_MODNAME__define
	obj = { MOD_MODNAME		   		,$
			inherits LUPEMOD   		,$
			idxxx:				0L	 $ ; widget IDs
		  }
end



;==============================================================================
;
;                             NON-UI RELATED METHODS
;
;==============================================================================
